std::string createVM(const postVM& data)
{
    char buffer[1024];
    std::string osVM_name; // Тип операционной системы
    std::string osVM_install; // Путь к установочному диску
    
    std::ostringstream oss_createVM;
    // Создаст виртуальный жёсткий диск
    std::string command = "qemu-img create -f qcow2 -o preallocation=metadata /home/gt/iso/" + data.nameVM + ".qcow2 " + data.hddVM + "G";
    std::shared_ptr<FILE> pipe(popen(command.c_str(), "r"), pclose);
    if (!pipe) throw std::runtime_error("popen() failed!");
    if (fgets(buffer, 1024, pipe.get()) != nullptr) 
    {
        oss_createVM << "Виртуальный жёсткий диск: <br>" << buffer << "<br>" << std::endl;
        switch(std::stoi(data.osVM))
        {
            case 1: osVM_name="Alpine-3.18"; osVM_install = "/home/gt/iso/install/alpine-standard-3.18.6-x86_64.iso"; break;
            case 2: osVM_name="Debian-11.9"; osVM_install = "/home/gt/iso/install/debian-11.9.0-amd64-netinst.iso"; break;
            case 3: osVM_name="Win-10"; osVM_install = "/home/gt/iso/install/Win10_22H2_Russian_x64v1.iso"; break;
            default: osVM_name="Alpine-3.18" ; osVM_install = "/home/gt/iso/install/alpine-standard-3.18.6-x86_64.iso";
        }
        // Создаст виртуальную машину
        command = "\
        virt-install \
	--connect=qemu:///system \
	--virt-type=kvm \
	--accelerate \
	--hvm \
	--vcpus=" + data.kernelVM+" \
	--ram=" + std::to_string((std::stoi(data.memVM) * 1024)) + " \
	--video=cirrus \
	--graphics vnc,listen=0.0.0.0" + (sizeof(data.passVM) ? ",password=" + data.passVM :  "" ) +" \
	--noautoconsole \
	--network network=default,model=virtio \
	--network network=default,type=direct,source=enp2s0,model=e1000 \
	--boot hd,cdrom,menu=on \
	--disk device=cdrom,perms=ro,format=raw,path=" + osVM_install + " \
	--disk device=disk,bus=virtio,cache=none,format=qcow2,path=/home/gt/iso/" + data.nameVM + ".qcow2 \
	--name=" + data.nameVM;
        std::shared_ptr<FILE> pipe(popen(command.c_str(), "r"), pclose);
        if (!pipe) throw std::runtime_error("popen() failed!");
        //double video_duration = 0.0;
        oss_createVM<< "Виртуальная машина: " <<  data.nameVM;
        for (;fgets(buffer, 1024, pipe.get()) != nullptr;) 
        {
            oss_createVM<< buffer;
        }
        oss_createVM<< std::endl;
    }
    return oss_createVM.str();
}
