std::map<std::string, std::string> parseData(const std::string& data) {
    std::map<std::string, std::string> result;
    std::string keyValuePair;
    std::istringstream stream(data);

    while (std::getline(stream, keyValuePair, '&')) {
        size_t pos = keyValuePair.find('=');
        if (pos != std::string::npos) {
            std::string key = keyValuePair.substr(0, pos);
            std::string value = keyValuePair.substr(pos + 1);
            result[key] = value;
        }
    }

    return result;
}


// Функция для получения значений куки из заголовка
std::map<std::string, std::string> getCookies(const std::string& request) {
    std::map<std::string, std::string> cookies;
    std::string line;
    std::istringstream request_stream(request);

    while (std::getline(request_stream, line)) {
        if (line.find("Cookie: ") == 0) {
            size_t pos = line.find("Cookie: ") + 8; // Начало значений куки
            std::string cookieData = line.substr(pos);
            cookies = parseData(cookieData);
            break;
        }
    }

    return cookies;
}
