// Основная маршрутизация страниц
std::string parseRequest(const std::string& request) 
{
    bool user_auth_status = false;
    std::string method, path, data;
    std::istringstream request_stream(request);
    int user_id = 0;
    request_stream >> method >> path; // Получаем метод и путь

    /* postVM post_create_vm; */
    std::string line;
    std::map<std::string, std::string> cookies;
    while (std::getline(request_stream, line) && line != "") {
                // Собираем заголовки и получаем куки
        if (line.find("Cookie: ") == 0) 
        {
            cookies = getCookies(request);
        }
    }
    
   
    std::string key = "user_id";
    // Проверка наличия ключа и получение значения
    if (cookies.find(key) != cookies.end()) {
        std::string value = cookies[key]; // или cookies.at(key);
        std::cout << "Значение по ключу '" << key << "': " << value << std::endl;
        user_id = std::stoi(value.c_str());
    } 
  //      else {
  //      std::cout << "Ключ '" << key << "' не найден!" << std::endl;
  //  } 
    


    // Если это POST запрос, то нужно получить данные
        if (method == "POST") 
        {
            // Получаем длину содержимого
            while (std::getline(request_stream, line)) 
            {
                if (line.find("Content-Length: ") != std::string::npos) 
                {
                    int content_length = std::stoi(line.substr(16));
                    data.resize(content_length);
                    request_stream.read(&data[0], content_length);
                    break;
                }
            }
  /////////////////////////////////////////
  //            Функционал  для POST
  /////////////////////////////////////////
  
            
                switch(std::stoi(path.substr(1)))
                {
                    // Регистрация
                    case 1: return handlePOST(reg(reg_init(line))); break;
                    // Авторизация
                    case 2: return auth_set_cookie(auth(auth_init(line), user_id), user_id); break;
                    // Создание новой VM
                    case 3: return handlePOST(createVM(init_createVM(line))); break;
                    // список VM
               //     case 4: return listVM_html(path); break;
                    // По-умолчанию: открыть главную страницу
                    default: return mainGET(path);
                }             
            
            
  
            // Создание виртуальной машины при запросе POST
            //return handlePOST(createVM(init_createVM(line)));
        }
        else if (method == "GET") 
        {
            // Главная страница
           //     std::cout << "Главная страница:" << path.substr(1) << std::endl;
            if(( path == "/" ) || (path == "/favicon.ico"))
            {
                // Главная страница
                return mainGET(path);
            }
            else
                switch(std::stoi(path.substr(1)))
                {
                    // Регистрация
                    case 1: return regGET(path); break;
                    // Авторизация
                    case 2: return authGET(path); break;
                    // Создание новой VM
                    case 3: return createVM_html(path); break;
                    // Список VM
                    case 4: return listVM_html(path); break;
                    // По-умолчанию: открыть главную страницу
                    default: return mainGET(path);
                } 
        }

    return "HTTP/1.1 405 Method Not Allowed\n"
           "Connection: close\n"
           "\n";
}
